package Echiquier;

import Echiquier.Piece.Piece;

public class Case{
    //le numéro de ligne
    private int lig;
    //le numéro de colonne
    private int col;
    //le piece dans le case
    private Piece piece;
    //Echique
    private Echiquier echiquier;

    public Case(int lig, int col) throws EchiquierException {
        if(lig < 0 || col < 0)
            throw new EchiquierException("La colonne et ligne ne peuvent pas être inférieur à 0");
        this.lig = lig;
        this.col = col;
    }

    public boolean estEuPiece(){
        if(null == piece)
            return false;
        return true;
    }

    public Piece getPiece() {
        return piece;
    }

    public void setPiece(Piece piece) {
        this.piece = piece;
    }

    public int getCol() {
        return col;
    }

    public void setEchiquier(Echiquier echiquier){
        this.echiquier = echiquier;
    }

    public int getLig() {
        return lig;
    }

    public String toString(){
        return "(" + (Echiquier.MAXLIG - lig) + "," + (char)('A'+ col) + ")";
    }

    public boolean estBloqueDiagonales(Case depart, Case arrvie){
        if(estEnDiagonales(depart,arrvie)){
            if(null != echiquier){
                //Si l'arrive est en haut à droite
                int nb = depart.getLig() - arrvie.getLig();
                if(depart.getLig()-arrvie.getLig()>0 && depart.getCol()-arrvie.getCol()>0){
                    for(int i=1;i<nb; i++){
                        if(echiquier.getCase(depart.getLig()+i,depart.getCol()+i).estEuPiece())
                            return false;
                    }
                }

                //Si l'arrive est en haut à gauche
                if(depart.getLig()-arrvie.getLig()>0 && depart.getCol()-arrvie.getCol()<0){
                    for(int i=1;i<nb; i++){
                        if(echiquier.getCase(depart.getLig()+i,depart.getCol()-i).estEuPiece())
                            return false;
                    }
                }

                //Si l'arrive est en base à gauche
                if(depart.getLig()-arrvie.getLig()<0 && depart.getCol()-arrvie.getCol()<0){
                    for(int i=1;i<nb; i++){
                        if(echiquier.getCase(depart.getLig()-i,depart.getCol()-i).estEuPiece())
                            return false;
                    }
                }

                //Si l'arrive est en base à droite
                if(depart.getLig()-arrvie.getLig()<0 && depart.getCol()-arrvie.getCol()>0){
                    for(int i=1;i<nb; i++){
                        if(echiquier.getCase(depart.getLig()-i,depart.getCol()+i).estEuPiece())
                            return false;
                    }
                }
            }else
                return false;
        }else
            return false;

        return true;
    }

    public boolean estBloqueDroit(Case depart, Case arrive){
        if(estEnLigne(depart,arrive)){
            if(null != echiquier){
                int nbCol = depart.getCol() - arrive.getCol();
                int nbLig = depart.getLig() - arrive.getLig();

                //La deplacement horizontal
                if(depart.getLig() == arrive.getLig()){
                    //A droit
                    if(nbCol>0){
                        for (int i=0;i<nbCol;i++){
                            if(echiquier.getCase(depart.getLig(), depart.getCol() + i).estEuPiece()){
                                return false;
                            }
                        }
                    }

                    //A gauche
                    if(nbCol>0){
                        for (int i=0;i<nbCol;i++){
                            if(echiquier.getCase(depart.getLig(), depart.getCol() - i).estEuPiece()){
                                return false;
                            }
                        }
                    }
                }

                //La deplacement vertical
                if(depart.getCol() == depart.getCol()){
                    //En haut
                    if(nbLig>0){
                        for (int i=0;i<nbLig; i++){
                            if(echiquier.getCase(depart.getLig() + i, depart.getCol()).estEuPiece()){
                                return false;
                            }
                        }
                    }
                    //En base
                    if(nbLig>0){
                        for (int i=0;i<nbLig; i++){
                            if(echiquier.getCase(depart.getLig() - i, depart.getCol()).estEuPiece()){
                                return false;
                            }
                        }
                    }
                }
            }else
                return false;
        }else
            return false;

        return true;
    }

    private boolean estEnLigne(Case depart,Case arrive){
        return depart.getLig() == arrive.getLig() || depart.getCol() == arrive.getCol();
    }

    //Verifier le deplacement est diagonales
    private boolean estEnDiagonales(Case depart, Case arrvie){
        return depart.getCol()-arrvie.getCol() == depart.getLig() - arrvie.getLig();
    }
}
